	.equ __24HJ64GP202, 1
;	.equ __24HJ256GP610, 1
;	.equ __33FJ256GP506, 1

.IFDEF __24HJ64GP202
  .include "p24hj64gp202.inc"
  .equiv rgb_port,LATB	; define RGB output port here
  .equiv vsync_port,LATA ; define VSYNC port...
  .equiv vsync_bit,0	; ...and bit at VSYNC port here
  .equiv kbd_port,PORTB	; define KBD Clock and Data port...
  .equiv kbd_clk,7	; ...and Clock input port bit...
  .equiv kbd_data,8	; ...and Data input port bit
  .equiv oc_byte,IFS0	; OC1IF byte
  .equiv oc_bit,0x0002	; OC1IF bit
    config __FBS,	RBS_NO_RAM   & BSS_NO_FLASH  & BWRP_WRPROTECT_OFF
    config __FSS,	RSS_NO_RAM   & SSS_NO_FLASH  & SWRP_WRPROTECT_OFF
    config __FGS,	GSS_OFF      & GCP_OFF       & GWRP_OFF
    config __FOSCSEL,	FNOSC_PRIPLL & IESO_OFF
    config __FOSC,	FCKSM_CSDCMD & OSCIOFNC_OFF  & POSCMD_XT
    config __FWDT,	FWDTEN_OFF   & WINDIS_OFF
    config __FPOR,	FPWRT_PWR128
    config __FICD,	JTAGEN_OFF   & ICS_PGD1
.ENDIF

.IFDEF __24HJ256GP610
  .include "p24hj256gp610.inc"
  .equiv rgb_port,LATD	; define RGB output port here
  .equiv vsync_port,LATD ; define VSYNC port...
  .equiv vsync_bit,8	; ...and bit at VSYNC port here
  .equiv kbd_port,PORTF	; define KBD Clock and Data port...
  .equiv kbd_clk,4	; ...and Clock input port bit...
  .equiv kbd_data,5	; ...and Data input port bit
  .equiv oc_byte,IFS2
  .equiv oc_bit,0x000C	; OC8IF
    config __FBS,	RBS_NO_RAM   & BSS_NO_FLASH  & BWRP_WRPROTECT_OFF
    config __FSS,	RSS_NO_RAM   & SSS_NO_FLASH  & SWRP_WRPROTECT_OFF
    config __FGS,	GSS_OFF      & GCP_OFF       & GWRP_OFF
    config __FOSCSEL,	FNOSC_PRIPLL & IESO_OFF
    config __FOSC,	FCKSM_CSDCMD & OSCIOFNC_OFF  & POSCMD_XT
    config __FWDT,	FWDTEN_OFF   & WINDIS_OFF
    config __FPOR,	FPWRT_PWR128
    config __FICD,	JTAGEN_OFF   & ICS_PGD1
.ENDIF

.IFDEF __33FJ256GP506
  .include "p33fj256gp506.inc"
  .equiv rgb_port,LATB	; define RGB output port here
  .equiv vsync_port,LATD ; define VSYNC port...
  .equiv vsync_bit,1	; ...and bit at VSYNC port here
  .equiv kbd_port,PORTG	; define KBD Clock and Data port...
  .equiv kbd_clk,2	; ...and Clock input port bit... (2)
  .equiv kbd_data,3	; ...and Data input port bit (3)
  .equiv oc_byte,IFS0	; byte
  .equiv oc_bit,0x0002	; OC1IF bit
    config __FBS,	RBS_NO_RAM   & BSS_NO_FLASH  & BWRP_WRPROTECT_OFF
    config __FSS,	RSS_NO_RAM   & SSS_NO_FLASH  & SWRP_WRPROTECT_OFF
    config __FGS,	GSS_OFF      & GCP_OFF       & GWRP_OFF
    config __FOSCSEL,	FNOSC_PRIPLL & IESO_OFF
    config __FOSC,	FCKSM_CSDCMD & OSCIOFNC_OFF  & POSCMD_XT
    config __FWDT,	FWDTEN_OFF   & WINDIS_OFF
    config __FPOR,	FPWRT_PWR128
    config __FICD,	BKBUG_ON     &JTAGEN_OFF     & ICS_PGD1    & COE_ON
.ENDIF

;------------------------------------------------------------------------------
.bss
.align (0x100)
RX_CIRCULAR:	.space 0x100	; MUST BE ALIGNED TO 0x100
.align (0x100)
TX_CIRCULAR:	.space 0x100	; MUST BE ALIGNED TO 0x100
.align (0x100)
BITTAB1:	.space 0x22	; MUST BE ALIGNED TO 0x100

RX_WR:		.space 1	; UART receive write pointer (low byte only)
RX_RD:		.space 1	; UART receive read pointer (low byte only)
TX_WR:		.space 1	; UART transmit write pointer (low byte only)
TX_RD:		.space 1	; UART transmit read pointer (low byte only)

FLAG:		.space 2	; bit 0: mode (reset:95.6%, set:4%)
				; bit 1: kbd handshaking (set if KBDBUF ready)
				; bit 2: Vertical synchronizing bit
				; bit 8: synchronized bit 0
				; bit 11: blinking character on
				; bit 12: follows kbd_clk
				; bit 13: toggler for RX/TX service
				; bit 14: toggler for colour line buffers

CURFLAG:	.space 2	; bit 0: 0 = cursor 1, 1 = cursor 2 
				; bit 1: hide unselected cursor
				; bit 2: hide both cursors
				; bit 3: cursor 1 on (used by routine)
				; bit 4: cursor 2 on (used by routine)

KBDFLAG:	.space 2	; bit 0: SHIFT down
				; bit 1: CTRL down
				; bit 2: ALT down
				; bit 3: ENTER down
				; bit 8: CAPS LOCK active
				; bit 9: NUM LOCK active
				; bit 10: SCROLL LOCK active

DUMMY:		.space 2	; dymmy word (directed by unregular cursor pos)
BUFFER:		.space 3000	; video mem
LINE_BUF:	.space 60+60+60	; LINE_BUF+0: characters
				; LINE_BUF+60: (colours wr/rd)
				; LINE_BUF+120: (colours rd/wr)
LINE_ARG:	.space 50	; bit0: 2x wid, bit1: 2x height, hi by: colours
KBDBUF:		.space 2	; ASCII byte rcvd from kbd (KBDFLAG not processed)
FREERUN:	.space 2	; freerunning counter, for blinking divider
LCOUNT9:	.space 2
LINECOUNT:	.space 2
KBDSTREAM:	.space 4	; working kbd buffer, lo byte (bit 7) serial in
KBDSTREAM2:	.space 4	; final kbd buffer, lo byte (bit 7) serial in
KBDCOUNT:	.space 2	; hi byte: bit counter, lo byte: byte counter
KBDCOUNT2:	.space 2	; final kbd byte counter
CURSOR1:	.space 2	; X, Y cursor 1
CURSOR2:	.space 2	; X, Y cursor 2
DOCOUNT:	.space 2	; simulated docount for line and box drawing
DOCOUNT_INT:	.space 2	; temporary docount during interrupt
LINE_NUMBER:	.space 2	; text line counter, 0...24
NEXT_LINE:	.space 2	; next line argument from LINE_arg
SCREEN_ARG:	.space 2	; bit0: 2x wid, bit1: 2x height, hi by: colours
KBDPAT:		.space 2	; kbd patience timer, for next key detection
RAW_KEY:	.space 6	; for debugging only

CURCOL1:	.space 1	; cursor 1 colour
CURCOL2:	.space 1	; cursor 1 colour
CUR1SPEED:	.space 1	; cursor 1: 0=slow... 15=fast
CUR2SPEED:	.space 1	; cursor 2: 0=slow... 15=fast
PERIOD1:	.space 1	; cursor 1 blink period
PERIOD2:	.space 1	; cursor 2 blink period
PERIOD0:	.space 1	; character blink period
CURRENT_LINE:	.space 1	; current line argument H and W
BLINK_COUNT1:	.space 1	; cursor 1 blink counter
BLINK_COUNT2:	.space 1	; cursor 2 blink counter
BLINK_COUNT0:	.space 1	; character blink counter
SCAN_LINE:	.space 1	; scan line counter in 1 text line 0...23
MARGIN:		.space 1	; margin colour (bits 210 valid)
MARGINM:	.space 1	; mirror of margin colour (bits 654 valid)
BOUND_L:	.space 1	; cursor boundary left
BOUND_R:	.space 1	; cursor boundary right
BOUND_U:	.space 1	; cursor boundary up
BOUND_D:	.space 1	; cursor boundary down

;------------------------------------------------------------------------------

.text

.include "tables.inc"	; character set, bittab and kbd_codes
.include "macros.inc"	; macros

;------------------------------------------------------------------------------
.global __reset
__reset:
	mov #__SP_init,w15
	mov #__SPLIM_init,w0
	mov w0,_SPLIM

.IFDEF __24HJ64GP202
					; --- oscilator -----------------------
	mov	#0b0000000000000010,w0	; XT 8 MHz
	mov	w0,CLKDIV		; XT 8 MHz
	mov	#80,w0			; XT 8 MHz
	mov	w0,PLLFBD		; XT 8 MHz Feedback Divider
;	mov	#0b0000000000000100,w0	; FRC 7.37 MHz
;	mov	w0,CLKDIV		; FRC 7.37 MHz
;	mov	#130,w0			; FRC 7.37 MHz
;	mov	w0,PLLFBD		; FRC 7.37 MHz Feedback Divider
					; --- ADC -----------------------------
	mov	#0b1111111111111111,w0	; portovi digitalni
	mov	w0,AD1PCFGL
					; --- OUTPUT COMPARE ------------------
	mov	#0b0001001000000000,w0	; Compare1 on PORTB,#3
	mov	w0,RPOR1		; Compare1 on PORTB,#3
	mov	#1055-128,w0		; CP value for hor sync start 
	mov	w0,OC1R
	mov	#1055,w0		; CP value for hor sync end
	mov	w0,OC1RS
	mov	#0b0000000000000101,w0	; 101 = Continuous Pulse Mode
	mov	w0,OC1CON
					; --- TIMERS --------------------------
	mov	#0b1000000000000000,w0
	mov	w0,T2CON		; this timer needed for OC (hor sync)
	mov	#1056,w0		; 1056 pixels horizontal timing
	mov	w0,PR2
					; --- PORTS ---------------------------
	clr	LATA
	clr	LATB
	clr	ODCA
	clr	ODCB
	mov	#0b0000000000000000,w0
	mov	w0,TRISA
	mov	#0b0000000110000000,w0
	mov	w0,TRISB

	mov	#0b0000000011000000,w0
	mov	w0,CNPU2	; pull-ups on kbd pins (CN22 & CN23)
	bclr	RCON,#SWDTEN	; disable WDT
.ENDIF

.IFDEF __24HJ256GP610
					; --- oscilator -----------------------
	mov	#0b0000000000000000,w0	; XT 4 MHz
	mov	w0,CLKDIV		; XT 4 MHz
	mov	#80,w0			; XT 4 MHz
	mov	w0,PLLFBD		; XT 4 MHz Feedback Divider
;	mov	#0b0000000000000100,w0	; FRC 7.37 MHz
;	mov	w0,CLKDIV		; FRC 7.37 MHz
;	mov	#130,w0			; FRC 7.37 MHz
;	mov	w0,PLLFBD		; FRC 7.37 MHz Feedback Divider
					; --- ADC -----------------------------
	mov	#0b1111111111111111,w0	; portovi digitalni
	mov	w0,AD1PCFGL
	mov	w0,AD1PCFGH
	mov	w0,AD2PCFGL
					; --- OUTPUT COMPARE ------------------
	mov	#1055-128,w0		; CP value for the start of hor sync
	mov	w0,OC8R
	mov	#1055,w0		; CP value for the end of hor sync
	mov	w0,OC8RS
	mov	#0b0000000000000101,w0	; 101 = Continuous Pulse Mode
	mov	w0,OC8CON
					; --- TIMERS --------------------------
	mov	#0b1000000000000000,w0
	mov	w0,T2CON		; this timer needed for OC (hor sync)
	mov	#1056,w0		; 1056 pixels horizontal timing
	mov	w0,PR2
					; --- PORTS ---------------------------
	clr	LATA
	clr	LATB
	clr	LATC
	clr	LATD
	clr	LATE
	clr	LATF
	clr	LATG

	clr	ODCA
	clr	ODCD
	clr	ODCF
	clr	ODCG

	mov	#0b0000000000000000,w0
	mov	w0,TRISA
	mov	#0b0000000000000000,w0
	mov	w0,TRISB
	mov	#0b0000000000000000,w0
	mov	w0,TRISC
	mov	#0b0000000000000000,w0
	mov	w0,TRISD
	mov	#0b0000000000000000,w0
	mov	w0,TRISE
	mov	#0b0000000000110000,w0
	mov	w0,TRISF
	mov	#0b0000000000000000,w0
	mov	w0,TRISG

	mov	#0b0000000000000110,w0
	mov	w0,CNPU2	; pull-ups on kbd pins (CN17 & CN18)
	bclr	RCON,#SWDTEN	; disable WDT
.ENDIF

.IFDEF __33FJ256GP506
					; --- oscillator -----------------------
	mov	#0b0000000000000000,w0	; divider preset
	mov	w0,CLKDIV
	mov	#80,w0			; for XT oscilator 4 MHz
	mov	w0,PLLFBD		; PLL Feedback Divider
					; --- ADC -----------------------------
	mov	#0b1111111111111111,w0	; ports digital
	mov	w0,AD1PCFGL
	mov	w0,AD1PCFGH
					; --- OUTPUT COMPARE ------------------
	mov	#1055-128,w0
	mov	w0,OC1R
	mov	#1055,w0
	mov	w0,OC1RS
	mov	#0b0000000000000101,w0
	mov	w0,OC1CON
					; --- TIMERS --------------------------
	mov	#0b1000000000000000,w0
	mov	w0,T2CON
	mov	#1056,w0
	mov	w0,PR2
					; --- PORTS ---------------------------
	clr	LATB
	clr	LATC
	clr	LATD
	clr	LATF
	clr	LATG

	mov	#0b0000000000000000,w0
	mov	w0,TRISB
	mov	#0b0000000000000000,w0
	mov	w0,TRISC
	mov	#0b0000000000000000,w0
	mov	w0,TRISD
	mov	#0b0000000000000000,w0
	mov	w0,TRISF
	mov	#0b0000000000001100,w0
	mov	w0,TRISG

	bclr	RCON,#SWDTEN	; disable WDT
.ENDIF

;------------------------------------------ RAM clear

	mov	#0x800,w1
	repeat #4096-1
	clr	[w1++]

;---------------------------------------- bittab1 preset

	mov	#0b01110000,w0		; BKGND bits 6 5 4
	mov.b	WREG,BITTAB1
	mov	#0b00000111,w0		; FOREGND bits 2 1 0
	mov.b	WREG,BITTAB1+1
	mov.b	WREG,BITTAB1+2
	mov.b	WREG,BITTAB1+4
	mov.b	WREG,BITTAB1+8
	mov.b	WREG,BITTAB1+16
	mov.b	WREG,BITTAB1+32

	call	clr_buf
;--------------------------------

	setm	KBDPAT
	bclr	FLAG,#0			; PRESET MODE (CLR=full scr, SET=lines only)
	mov.b	#0x03,w0		; default cursor1 colour
	mov.b	WREG,CURCOL1
	mov.b	#0x06,w0		; default cursor2 colour
	mov.b	WREG,CURCOL2
	mov	#0x0304,w0		; default cursor1 Y,X position
	mov	WREG,CURSOR1
	mov	#0x0a10,w0		; default cursor2 Y,X position
	mov	WREG,CURSOR2
	mov.b	#8,w0			; default cursor blinking period
	mov.b	WREG,CUR1SPEED
	mov.b	WREG,CUR2SPEED
	call	setspeed
	mov.b	#20,w0			; default character blinking period
	mov.b	WREG,PERIOD0
	mov.b	#59,w0
	mov.b	WREG,BOUND_R
	mov.b	#24,w0
	mov.b	WREG,BOUND_D

.IFDEF __24HJ64GP202
	bset	IEC0,#OC1IE		; ENABLE INTERRUPT
.ENDIF

.IFDEF __24HJ256GP610
	bset	IEC2,#OC8IE		; ENABLE INTERRUPT
.ENDIF

.IFDEF __33FJ256GP506
	bset	IEC0,#OC1IE		; ENABLE INTERRUPT
.ENDIF

.include "template.inc"			; user's program

.include "demo.inc"	; demo and help routines (comment this out if you write
			; your own program, but don't wipe it out for the first
			; time, as it may be helpful for occasional testing)

;*******************************************************************************
;****************************                      *****************************
;****************************    OCx INTERRUPT     *****************************
;****************************                      *****************************
;*******************************************************************************

.IFDEF __24HJ64GP202
.global __OC1Interrupt
__OC1Interrupt:			; OC1 interrupt
.ENDIF

.IFDEF __24HJ256GP610
.global __OC8Interrupt
__OC8Interrupt:			; OC8 interrupt
.ENDIF

.IFDEF __33FJ256GP506
.global __OC1Interrupt
__OC1Interrupt:			; OC1 interrupt
.ENDIF

	push.s		; \
	push.d	w4	; \\
	push.d	w6	; \\\
	push.d	w8	; \\\\
	push.d	w10	; \\\\\
	push.d	w12	; \\\\\\
	push	w14	; \\\\\\\
	push	RCOUNT	; \\\\\\\\

	mov	LINECOUNT,WREG
	mov	#200,w1		; 25 lines * step 8 = 200
	sub	w0,w1,w1	; LINECOUNT-#200
	bra	z,lowerframe	; =200: it is lower frame
	bra	c,vertporch	; >200: it is vert porch or sync
				; <200: it is text
	btsc	FLAG,#8
	bra	mode25

;================================ mode 4.4% with full screen text

	clr	LINECOUNT
	mov.b	#25,w0
	mov.b	WREG,LCOUNT9
	mov	#BUFFER,w3
	mov	#tbloffset(chargen),w4	; pointer for chargen step 256

	call	horsync		; ***HS*** 
		extrajob

	mov	#BITTAB1,w6	; literal for video shifter
	mov	w6,w7		; literal for video shifter
	mov	#0x20,w8	; literal for video shifter
	mov	#0x10,w9	; literal for video shifter
	mov	#0x08,w10	; literal for video shifter
	mov	#0x04,w11	; literal for video shifter
	mov	#0x02,w12	; literal for video shifter
	mov	#0x01,w13	; literal for video shifter

	neg	TMR2,WREG
	add	#4*hor_coarse+55-hor_fine,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; timing align in 25 ns steps

	bset	rgb_port,#2	; blue UPPER LEFT
	mov.b	MARGINM,WREG
	mov.b	WREG,rgb_port	; upper margin line

	neg	TMR2,WREG
	add	#55+4*hor_coarse-hor_fine+801,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; timing align in 25 ns steps
	clr.b	rgb_port	; terminate the upper margin line

	mov	#2,w5
	btsc	SCREEN_ARG,#1
	mov	#6,w5
	btsc	LINE_ARG,#1
	mov	#6,w5

1:			; \
	btss	oc_byte,#oc_bit
	bra	1b
	neg	TMR2,WREG
	add	#4*hor_coarse+55-hor_fine,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; timing align in 25 ns steps
	bclr	oc_byte,#oc_bit	; clear int flag

	mov.b	MARGINM,WREG
	mov.b	WREG,rgb_port	; upper margin line

		extrajob

	neg	TMR2,WREG
	add	#55+4*hor_coarse-hor_fine+801,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; timing align in 25 ns steps
	clr.b	rgb_port	; terminate the upper margin line

	dec	w5,w5
	bra	nz,1b	; /

	st_current_next

	bra	3f
2:			; \
	mov	#tbloffset(chargen),w4	; pointer for chargen step 256

	st_current_next
5:
	rcall	line1
	rcall	term
	clr.b	[w1]
	btss	CURRENT_LINE,#1	; bit 1: height
	bra	4f		; single height
	dec.b	LCOUNT9,WREG
	bra	z,4f		; double height cannot start at the last line

	rcall	line3		; double height only
	rcall	term
	clr.b	[w1]
	l1l3
	rcall	line1		; double height only
	rcall	term
	clr.b	[w1]
4:
	rcall	line3
	rcall	term
	clr.b	[w1]
	l1l3
3:
	btss	CURRENT_LINE,#1	; bit 1: height
	bra	4f		; single height
	dec.b	LCOUNT9,WREG
	bra	z,4f		; double height cannot start at the last line
	l1l2			; double height starts here ==================
	l1l2
.rept #7
	add	#0x100,w4
	l1l2
	l1l2
.endr
	add	#0x100,w4
	l1l3
	l1l3
	add	#0x100,w4
	l1l3p1
	l1l3p2			; last line 3
	
	add	#240,w3		; double skip video buffer pointer
	mov	#16,w0		; double linecount advance
	add	LINECOUNT
	inc	LINE_NUMBER	; double: extra line_number advance
	dec.b	LCOUNT9		; double: extra decrement loop counter
	nop
	clr.b	[w1]		; terminate BKGND colour on the port
	bra	5f
4:				; single height starts here -------------------
	l1l2
.rept #7
	add	#0x100,w4
	l1l2
.endr
	add	#0x100,w4
	l1l3p1
	add	#0x100,w4
	l1l3p2			; last line 3
	add	#120,w3
	mov	#8,w0
	add	LINECOUNT
5:
	btg	FLAG,#14
	inc	LINE_NUMBER
	dec.b	LCOUNT9
	clr.b	[w1]		; terminate BKGND colour on the port
	bra	nz,2b	; /

	mov	#200,w0
	mov	w0,LINECOUNT	; prepare LINECOUNT for vert porch
	bra	int_exit
term:
	return
;================================ mode 23% for pure text mode
mode25:
	mov	LINECOUNT,WREG
	cp	w0,#1
	bra	nz,not_gornjiram

	call	horsync		; ***HS*** 
		extrajob

	mov.b	#8,w0
	mov.b	WREG,SCAN_LINE

	neg	TMR2,WREG
	add	#4*hor_coarse+55-hor_fine,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; timing align in 25 ns steps

	bset	rgb_port,#2	; blue UPPER LEFT
	nop
	bclr	rgb_port,#2
	inc	LINECOUNT


	btss	SCREEN_ARG,#1
	btsc	LINE_ARG,#1
	bra	extralines
	bra	exitline0
extralines:
	mov	#6,w5
syncx4:
	call	horsync		; ***HS*** 
		extrajob

	dec	w5,w5
	bra	nz,syncx4
exitline0:
	bra	int_exit

not_gornjiram:
	call	horsync		; ***HS***
		extrajob

	mov	#BITTAB1,w6	; literal for video shifter
	mov	w6,w7		; literal for video shifter
	mov	#0x20,w8	; literal for video shifter
	mov	#0x10,w9	; literal for video shifter
	mov	#0x08,w10	; literal for video shifter
	mov	#0x04,w11	; literal for video shifter
	mov	#0x02,w12	; literal for video shifter
	mov	#0x01,w13	; literal for video shifter

	st_current_next
3:
	btss	CURRENT_LINE,#1	; bit 1: height
	bra	4f		; single height

	mov.b	LINE_NUMBER,WREG
	cp.b	w0,#24	
	bra	z,4f		; double height cannot start at the last line
				; DOUBLE HEIGHT starts here
	
	mov.b	SCAN_LINE,WREG
	inc.b	SCAN_LINE
	cp.b	w0,#11
	bra	nc,int_exit	; because there is pause here (first 11 lines)

	mov	LINECOUNT,w2
	and	#0b11111000,w2
	mul.uu	w2,#15,w2	; that is multiplication by 120
				; pointer offset in text (text row counter * 120)
	mov	#BUFFER,w3
	add	w2,w3,w3	; w3 = rd ptr (address of char 1 in text row)
	mov	#tbloffset(chargen),w4	; pointer for chargen step 256
	
.rept #7			; 1 line of text (9x2 pixels lines)
	add	#0x100,w4
	l1l2
	l1l2
.endr
	add	#0x100,w4
	l1l3
	l1l3
	add	#0x100,w4
	l1l3p1
	l1l3p2			; last line 3
	mov	LINECOUNT,w0
	and	#0b11111000,w0
	add	#0x10,w0
	mov	w0,LINECOUNT
	inc2	LINE_NUMBER
	clr.b	SCAN_LINE
	clr.b	[w1]		; terminate BKGND port
	btg	FLAG,#14
	bra	int_exit
4:				; SINGLE HEIGHT starts here
	inc.b	SCAN_LINE
	mov	LINECOUNT,WREG
	inc	LINECOUNT
	and	#7,w0
	cp	w0,#5		; (LINECOUNT & 7) - #5
	bra	nc,int_exit	; pause here (linecount<5)

	mov	LINECOUNT,w2
	and	#0b11111000,w2
	mul.uu	w2,#15,w2
				; pointer offset in text (row count * 120)
	mov	#BUFFER,w3
	add	w2,w3,w3	; w3 = rd ptr (address of char 1 in the row)
	mov	#tbloffset(chargen),w4	; pointer for chargen step 256

.rept #7			; 1 line of text (9x2 pixels lines)
	add	#0x100,w4
	l1l2
.endr
	add	#0x100,w4
	l1l3p1
	add	#0x100,w4
	l1l3p2			; last line 3
	rcall	term
	clr.b	[w1]
	inc2	LINECOUNT	; to make LINECOUNT for pause and text row = 8
	inc	LINE_NUMBER

	clr.b	SCAN_LINE
	btg	FLAG,#14
	bra	int_exit
;__________________________________________________________________________________

;-------------- line 200 is the lower border and KBD conversion
lowerframe:
	call	horsync		; ***HS*** 
		extrajob

	btsc	FLAG,#0
	bra	nobottom

	neg	TMR2,WREG	; hor sync aligning
	add	#hor_align+54,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; TMR1 align in 25 ns steps
	bclr	oc_byte,#oc_bit	; clr int flag

	mov.b	MARGINM,WREG	; MARGIN COLOR
	mov.b	WREG,rgb_port	; MARGIN COLOR
nobottom:
	mov	KBDSTREAM2,w0;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	w0,RAW_KEY;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	KBDSTREAM2+2,w0;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	w0,RAW_KEY+2;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	KBDCOUNT2,w0;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	mov	w0,RAW_KEY+4;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
				; convert kbd input from KBDSTREAM (4 bytes)
	cp0	KBDCOUNT2
	bra	z,bottom
	clr	KBDCOUNT2

;	mov	DEBUG,w0
;	bra	kbd_store

;-------------------------------- KBDSTREAM from keyboard
	clr	KBDCOUNT2
	mov	KBDSTREAM2+2,w0
	mov	#0x77f0,w1
	cp	w0,w1
	bra	nz,notpause
	mov	KBDSTREAM2,w0
	mov	#0x14f0,w1
	bra	nz,bottom	; trash
	mov	#147,w0		; pause code
	bra	kbd_store
notpause:
	mov	#0xf0,w1
	cp.b	w0,w1
	bra	z,break_code	; jer je break code
	mov	#tbloffset(codes_e0),w2
	mov	#0xe0,w1
	cp.b	w0,w1
	bra	z,e0_code	; jer je E0,xx code
;	cp0.b	w0
;	bra	nz,bottom	; trash (pretposlednji bajt nije 00,e0,f0)
	mov	#tbloffset(codes_00),w2
e0_code:			; code is in high byte w0 and table address in u w2
	clr.b	w0
	swap	w0
	add	w0,w2,w1
	tblrdl.b [w1],w0	; read ASCII or spec code from the table
kbd_store:
	clr	KBDBUF
	mov.b	WREG,KBDBUF	; WRITE
	bset	FLAG,#1		; set handshaking flag
	bra	bottom		; continue
break_code:
	swap	w0
	mov	w0,w1

	mov	#220,w0
	cp.b	w1,#0x12
	bra	z,kbd_store	; L SHIFT break

	mov	#221,w0
	cp.b	w1,#0x14
	bra	z,kbd_store	; CTRL break

	mov	#222,w0
	cp.b	w1,#0x11
	bra	z,kbd_store	; ALT break

	sub	#0x50,w1

	mov	#220,w0
	cp.b	w1,#0x9
	bra	z,kbd_store	; R SHIFT break

	mov	#223,w0
	cp.b	w1,#0xa
	bra	z,kbd_store	; ENTER break

bottom:				; lower border
	;------------------------ cursors blink
	inc	FREERUN

	inc.b	BLINK_COUNT1
	btsc	SR,#Z
	bset	CURFLAG,#3	; if blink_count1 was 0xff, set cursor1 blink flag
	mov.b	BLINK_COUNT1,WREG
	cp.b	PERIOD1
	bra	c,1f
	btg	CURFLAG,#3	; cursor 1 blink
	clr.b	BLINK_COUNT1
1:
	btss	CURFLAG,#0
	bra	2f
	bset	CURFLAG,#3	; cursor 1 permanent ON if cursor 2 selected
	btsc	CURFLAG,#1
	bclr	CURFLAG,#3	; curs1 permanent OFF if curs2 sel & CURFLAG,#1 set
2:
	inc.b	BLINK_COUNT2
	btsc	SR,#Z
	bset	CURFLAG,#4	; if blink_count2 was 0xff, set cursor2 blink flag
	mov.b	BLINK_COUNT2,WREG
	cp.b	PERIOD2
	bra	c,1f
	btg	CURFLAG,#4	; cursor 2 blink
	clr.b	BLINK_COUNT2
1:
	btsc	CURFLAG,#0
	bra	2f
	bset	CURFLAG,#4	; cursor 2 permanent ON if cursor 1 selected
	btsc	CURFLAG,#1
	bclr	CURFLAG,#4	; curs2 permanent OFF if curs1 sel & CURFLAG,#1 set
2:
	btsc	CURFLAG,#2
	bclr	CURFLAG,#3	; both off if CURFLAG,#2 set
	btsc	CURFLAG,#2
	bclr	CURFLAG,#4	; both off if CURFLAG,#2 set

	inc.b	BLINK_COUNT0
	mov.b	BLINK_COUNT0,WREG
	cp.b	PERIOD0
	bra	c,1f
	btg	FLAG,#11	; character blink
	clr.b	BLINK_COUNT0
1:
	cp0.b	PERIOD1
	btsc	SR,#Z
	bclr	CURFLAG,#3	; if PERIOD=0, then no cursor
	btsc.b	PERIOD1,#7
	bset	CURFLAG,#3	; if PERIOD>127, then permanent cursor

	cp0.b	PERIOD2
	btsc	SR,#Z
	bclr	CURFLAG,#4	; if PERIOD=0, then no cursor
	btsc.b	PERIOD2,#7
	bset	CURFLAG,#4	; if PERIOD>127, then permanent cursor

	cp0.b	PERIOD0
	btsc	SR,#Z
	bclr	FLAG,#11	; if PERIOD=0, then no char
	btsc.b	PERIOD0,#7
	bset	FLAG,#11	; if PERIOD>127, then permanent char

	neg	TMR2,WREG
	add	#55+4*hor_coarse-hor_fine+799,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; timing align in 25 ns steps

	bset	rgb_port,#2		; blue dot bottom right
	nop
	clr.b	rgb_port

	mov.b	MARGIN,WREG
	and	#7,w0
	swap.b	w0
	mov.b	WREG,MARGINM

	bclr	FLAG,#8
	btsc	FLAG,#0
	bset	FLAG,#8		; copy FLAG bit 0 to bit 8

	inc	LINECOUNT
	bra	int_exit

;----------------------------------------

vertporch:			; LINECOUNT = 201...228
		extrajob
	inc	LINECOUNT
	mov	LINECOUNT,WREG
	mov	#201,w1		; linecount-201
	cp	w0,w1
	bra	z,int_exit
	mov	#229,w1
	mov	#1,w2
	cp	w0,w1		; linecount-229
	btsc	SR,#Z
	mov	w2,LINECOUNT	; RESET LINECOUNT TO #1
	mov	#206,w1
	cp	w0,w1		; linecount-206
	bra	c,porch23
	bset	vsync_port,#vsync_bit	; vert sync mark
	bset	FLAG,#2
	bra	int_exit
porch23:
	clr	LINE_NUMBER
	bclr	vsync_port,#vsync_bit	; vert sync space
int_exit:
	pop	RCOUNT	; ////////
	pop	w14	; ///////
	pop.d	w12	; //////
	pop.d	w10	; /////
	pop.d	w8	; ////
	pop.d	w6	; ///
	pop.d	w4	; //
	pop.s		; /
	bclr	oc_byte,#oc_bit	; clr int flag
	retfie

;===============================================================================

.equ	hor_align,40		; for jitter avoiding routine (do not touch this)
.equ	hor_coarse,13 		; initial hor pos, 4 pix step (do not touch this)
.equ	hor_fine,13 		; adjust for fine hor pos, 1 pix step

horsync:
1:
	btss	oc_byte,#oc_bit
	bra	1b
	neg	TMR2,WREG
	add	#hor_align,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; timing align in 25 ns steps
	bclr	oc_byte,#oc_bit	; clr int flag
	return
;_________________________________________________________________________________

line1:				; w0, w1, w2 i w5 free!
	mov	#120,w14
	btss	FLAG,#14
	mov	#60,w14
				; ulaz: w3 = buffer read pointer (ne menja se ovde)
	mov	w4,w2		; ulaz: w4 = chargen row pointer (ne menja se ovde)
	mov	w4,w1		; ulaz: w4 = chargen row pointer (ne menja se ovde)
	mov	#LINE_BUF,w5	; temp buffer

		mov.b	[w3+0],w2
		mov.b	[w3+2],w1
		tblrdl.b [w2],[w5++]
.irp pos,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24
		mov.b	[w3+(\pos)*4+4],w2
		tblrdl.b [w1],[w5++]
		mov.b	[w3+(\pos)*4+6],w1
		tblrdl.b [w2],[w5++]
.endr
1:
	btss	oc_byte,#oc_bit
	bra	1b

		extrajob

	neg	TMR2,WREG	; hor sync aligning
	add	#hor_align+28,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; TMR1 align in 25 ns steps
	bclr	oc_byte,#oc_bit	; clr int flag

.irp pos,0,1,2,3
		mov.b	[w3+(\pos)*4+(24*4)+8],w2
		tblrdl.b [w1],[w5++]
		mov.b	[w3+(\pos)*4+(24*4)+10],w1
		tblrdl.b [w2],[w5++]
.endr
		tblrdl.b [w1],[w5++]
draw1:
	mov.b	MARGINM,WREG	; BACKGROUND COLOR
	mov.b	WREG,rgb_port	; BACKGROUND COLOR
	mov.b	#14,w0
	mov	#LINE_BUF,w5
	mov.b	WREG,DOCOUNT_INT
	mov	#rgb_port,w1	; const

	btsc.b	CURRENT_LINE,#0
	bra	double_width1
	nop
		; ******************** char 1
	and.b	w8,[w5],w6	; const bit5set & temp_buf 5...0 = w6
	mov.b	[w5+w14],w0	; colour
	and.b	w9,[w5],w7
	and.b	w0,[w6],[w1]	; 1    colour & w6 (00 ili FF) = PORTB
	and.b	w10,[w5],w6
	and.b	w0,[w7],[w1]	; 2
	and.b	w11,[w5],w7
	and.b	w0,[w6],[w1]	; 3
	and.b	w12,[w5],w6
	and.b	w0,[w7],[w1]	; 4
	and.b	w13,[w5++],w7
	and.b	w0,[w6],[w1]	; 5
	mov.b	[w5+w14],w2	; colour
	and.b	w0,[w7],[w1]	; 6
	and.b	w8,[w5],w6

    .rept #29
			; ******************** chars 2, 4, 6, 8... 58
		and.b	w9,[w5],w7
		and.b	w2,[w6],[w1]	; 1
		and.b	w10,[w5],w6
		and.b	w2,[w7],[w1]	; 2
		and.b	w11,[w5],w7
		and.b	w2,[w6],[w1]	; 3
		and.b	w12,[w5],w6
		and.b	w2,[w7],[w1]	; 4
		and.b	w13,[w5++],w7
		and.b	w2,[w6],[w1]	; 5
		mov.b	[w5+w14],w0	; colour
		and.b	w2,[w7],[w1]	; 6
		and.b	w8,[w5],w6
			; -------------------- chars 3, 5, 7, 9... 59
		and.b	w9,[w5],w7
		and.b	w0,[w6],[w1]	; 1
		and.b	w10,[w5],w6
		and.b	w0,[w7],[w1]	; 2
		and.b	w11,[w5],w7
		and.b	w0,[w6],[w1]	; 3
		and.b	w12,[w5],w6
		and.b	w0,[w7],[w1]	; 4
		and.b	w13,[w5++],w7
		and.b	w0,[w6],[w1]	; 5
		mov.b	[w5+w14],w2	; colour
		and.b	w0,[w7],[w1]	; 6
		and.b	w8,[w5],w6
    .endr		; ******************** char 60

	and.b	w9,[w5],w7
	and.b	w2,[w6],[w1]	; 1
	and.b	w10,[w5],w6
	and.b	w2,[w7],[w1]	; 2
	and.b	w11,[w5],w7
	and.b	w2,[w6],[w1]	; 3
	and.b	w12,[w5],w6
	and.b	w2,[w7],[w1]	; 4
	and.b	w13,[w5++],w7
	and.b	w2,[w6],[w1]	; 5
	mov.b	MARGINM,WREG
	and.b	w2,[w7],[w1]	; 6

		; **********************************************************
	mov.b	w0,[w1]
	return

double_width1:
		; ******************** char 1
	and.b	w8,[w5],w6	; const bit5set & temp_buf 5...0 = w6
	mov.b	[w5+w14],w0	; colour
	and.b	w9,[w5],w7
	and.b	w0,[w6],[w1]	; 1    colour & w6 (00 ili FF) = PORTB
	mov.d	w0,w0		; wait two cycles
	and.b	w10,[w5],w6
	and.b	w0,[w7],[w1]	; 2
	mov.d	w0,w0
	and.b	w11,[w5],w7
	and.b	w0,[w6],[w1]	; 3
	mov.d	w0,w0
	and.b	w12,[w5],w6
	and.b	w0,[w7],[w1]	; 4
	mov.d	w0,w0
	and.b	w13,[w5++],w7
	and.b	w0,[w6],[w1]	; 5
	mov.d	w0,w0
	mov.b	[w5+w14],w2	; colour
	and.b	w0,[w7],[w1]	; 6
	mov.d	w0,w0
	nop
chars14:		; ******************** chars 2, 4, 6, 8... 28
		and.b	w8,[w5],w6
		and.b	w9,[w5],w7
		and.b	w2,[w6],[w1]	; 1
		mov.d	w0,w0
		and.b	w10,[w5],w6
		and.b	w2,[w7],[w1]	; 2
		mov.d	w0,w0
		and.b	w11,[w5],w7
		and.b	w2,[w6],[w1]	; 3
		mov.d	w0,w0
		and.b	w12,[w5],w6
		and.b	w2,[w7],[w1]	; 4
		mov.d	w0,w0
		and.b	w13,[w5++],w7
		and.b	w2,[w6],[w1]	; 5
		mov.d	w0,w0
		mov.b	[w5+w14],w0	; colour
		and.b	w2,[w7],[w1]	; 6
		mov.d	w0,w0
		nop
			; -------------------- chars 3, 5, 7, 9... 29
		and.b	w8,[w5],w6
		and.b	w9,[w5],w7
		and.b	w0,[w6],[w1]	; 1
		mov.d	w0,w0
		and.b	w10,[w5],w6
		and.b	w0,[w7],[w1]	; 2
		mov.d	w0,w0
		and.b	w11,[w5],w7
		and.b	w0,[w6],[w1]	; 3
		mov.d	w0,w0
		and.b	w12,[w5],w6
		and.b	w0,[w7],[w1]	; 4
		mov.d	w0,w0
		and.b	w13,[w5++],w7
		and.b	w0,[w6],[w1]	; 5
		mov.d	w0,w0
		mov.b	[w5+w14],w2	; colour
		and.b	w0,[w7],[w1]	; 6
		dec.b	DOCOUNT_INT
		bra	nz,chars14
			; ******************** char 30
	and.b	w8,[w5],w6
	and.b	w9,[w5],w7
	and.b	w2,[w6],[w1]	; 1
	mov.d	w0,w0
	and.b	w10,[w5],w6
	and.b	w2,[w7],[w1]	; 2
	mov.d	w0,w0
	and.b	w11,[w5],w7
	and.b	w2,[w6],[w1]	; 3
	mov.d	w0,w0
	and.b	w12,[w5],w6
	and.b	w2,[w7],[w1]	; 4
	mov.d	w0,w0
	and.b	w13,[w5++],w7
	and.b	w2,[w6],[w1]	; 5
	mov.d	w0,w0
	mov.b	MARGINM,WREG
	and.b	w2,[w7],[w1]	; 6
	mov.d	w0,w0
		; **********************************************************
	nop
	nop
	mov.b	w0,[w1]
	return

;--------------------------------
line2:
	mov	#LINE_BUF,w5	; temp buffer

	btss	CURFLAG,#4	; START CURSOR 2 -----------------
	bra	1f
	mov	LINE_NUMBER,WREG	; w0= row No. 0...24
	cp.b	CURSOR2+1
	bra	nz,1f		; if cursor is not at that row
	mov	#60,w2
	clr	w0
	mov.b	CURSOR2,WREG	; w0 = cursor X pos
	cp	w0,w2
	bra	c,1f		; cursor x pos overflow
	add	w0,w5,w2	; w2=cursor position in line_buf
	mov	#0b00111110,w0	; cursor width
	mov.b	w0,[w2]		; draw cursor in line buf
	mov.b	CURCOL2,WREG	; cursor colour
	and	#7,w0
	add	#60,w2
	btsc	FLAG,#14
	add	#60,w2
	mov.b	[w2],w1		; get colour
	and.b	#0b11111000,w1	; remove char color, hold bkgnd
	ior.b	w1,w0,[w2]	; put cursor colour in line buf
1:				; END CURSOR 2 -----------------
	
	btss	CURFLAG,#3	; START CURSOR 1 -----------------
	bra	1f
	mov	LINE_NUMBER,WREG	; w0= row No. 0...24
	cp.b	CURSOR1+1
	bra	nz,1f		; if cursor is not at that row
	mov	#60,w2
	clr	w0
	mov.b	CURSOR1,WREG	; w0 = cursor X pos
	cp	w0,w2
	bra	c,1f		; cursor x pos overflow
	add	w0,w5,w2	; w2=cursor position in line_buf
	mov	#0b00111110,w0	; cursor width
	mov.b	w0,[w2]		; draw cursor in line buf
	mov.b	CURCOL1,WREG	; cursor colour
	and	#7,w0
	add	#60,w2
	btsc	FLAG,#14
	add	#60,w2
	mov.b	[w2],w1		; get colour
	and.b	#0b11111000,w1	; remove char colour, hold bkgnd
	ior.b	w1,w0,[w2]	; put cursor colour in line buf
1:				; END CURSOR 1 -----------------
2:
	btss	oc_byte,#oc_bit
	bra	2b
	neg	TMR2,WREG	; hor sync aligning
	add	#hor_align,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; TMR1 align in 25 ns steps
	bclr	oc_byte,#oc_bit	; clr int flag

		extrajob

	neg	TMR2,WREG
	add	#1+(hor_coarse*4)+hor_align,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; timing align in 25 ns steps
	bra	draw1

;--------------------------------
				; w0, w1, w2 i w5 free!
group_param:			; \
	mov	#tbloffset(blinktab),w0
	mov.b	NEXT_LINE+1,WREG ; WREG0L: grup param for the whole line
	
	mov.b	#0b01110111,w2
	btsc	FLAG,#11
	and.b	w0,w2,w0
	tblrdl.b [w0],w2
	repeat #29
	mov.b	w2,[w5++]

	bra	line3

line4:
	mov	#LINE_BUF+60,w5	; wr ptr
	mov	#1,w1
	bra	linex
line5:
	mov	#LINE_BUF+60+30,w5
	mov	#61,w1
linex:
	btss	FLAG,#14
	add	#60,w5		; w5 = ptr for colur write in line buf
				; after this, w5=line_buf+60  +90  +120  +150
	cp0.b	NEXT_LINE+1	; here are parametres  T BBB T FFF
	bra	nz,group_param	; /

	mov	w3,w2		; rd ptr
	btsc	CURRENT_LINE,#1
	add	#120,w2		; if double height

	add	#120,w2		; next line ptr
	mov	#BUFFER+2999,w0
	cp	w0,w2
	btss	SR,#C
	mov	#BUFFER,w2
	add	w2,w1,w2	; w2 = ptr for colour reading from buffer
	mov.b	#0b11111111,w0
	btsc	FLAG,#11
	mov.b	#0b01110111,w0	; w0 = 0b11111111 or 0b01110111 (blink bits 7,3)
	mov	#tbloffset(blinktab),w1
.rept #30
	mov.b	[w2++],w1
	and.b	w0,w1,w1	; offset 0 or 8 or 128 or 136 (blinking)
	inc	w2,w2
	tblrdl.b [w1],[w5++]
.endr

line3:			; only w0, w1, w2 and w5 can be trashed here!
	mov	w3,w2		; ulaz: w3 = buffer read pointer (ne menja se ovde)
	mov	#LINE_BUF,w5	; temp buffer
9:
	btss	oc_byte,#oc_bit
	bra	9b
;	neg	TMR2,WREG	; hor sync align
;	add	#hor_align,w0
;	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
;	nop			; TMR1 align in 25 ns steps
	bclr	oc_byte,#oc_bit	; clr int flag

		extrajob

	neg	TMR2,WREG
	add	#1+(hor_coarse*4)+hor_align,w0
	repeat	w0		; <><><><><><><><><><><><><><><><><><><><><><><><>
	nop			; timing align in 25 ns steps
	bra	draw1

;------------------------------------------------------------------------------
;extrajob:			; tests KBDCLOCK i rotates KBDDATA in KBDSTREAM
;				; 25T max + return
;
;	btsc	kbd_port,#kbd_clk	; kbd_clk
;	bra	kbd_clk_hi
;	btst	FLAG,#12
;	bclr	FLAG,#12	; FLAG,#12 only follows kbd_clk
;	bra	z,not_falling_edge
;				; clock falling edge
;	clr	KBDPAT
;	dec.b	KBDCOUNT+1,WREG
;	inc.b	KBDCOUNT+1
;	cp.b	w0,#8
;	bra	nc,databits
;	cp.b	w0,#9
;	bra	z,framed	; here was bit 9: end of byte
;	return			; if the counter was 0-9-10, it only returns
;databits:
;	mov	#kbd_port,w0
;	btst.c	[w0],#kbd_data	; KBD DATA
;	rrc	KBDSTREAM+2
;	rrc	KBDSTREAM
;	return
;framed:			; end of one byte (9. bit just received)
;	clr.b	KBDCOUNT+1
;	inc.b	KBDCOUNT
;	return
;
;kbd_clk_hi:
;	bset	FLAG,#12	; FLAG,#12 only follows kbd_clk
;not_falling_edge:
;	btsc	KBDPAT,#15
;	bra	uart_service	; because KBDPAT is in default state 0xff
;	inc	KBDPAT
;	btss	KBDPAT,#7	; 128 cycles by 26,4us
;	bra	uart_service	; because KBDPAT still did not measure 1,69ms
;	mov	KBDSTREAM,w0
;	mov	w0,KBDSTREAM2
;	clr	KBDSTREAM
;	mov	KBDSTREAM+2,w0
;	mov	w0,KBDSTREAM2+2
;	clr	KBDSTREAM+2
;	mov.b	KBDCOUNT,WREG
;	mov.b	WREG,KBDCOUNT2
;	clr	KBDCOUNT
;	setm	KBDPAT
;	return
;
;uart_service:		;-------- UART START (might the timing be critical!!!)
;
;	btg	FLAG,#13
;	btss	FLAG,#13
;	bra	go_tx
;				; UART service, 17T max
;	btss	U1STA,#URXDA
;	return			; RX register empty
;	mov	w0,RX_CIRCULAR
;	inc2.b	RX_WR,WREG
;	cp.b	RX_RD
;	bra	z,no_rx_rq	; no room in FIFO256
;	mov	U1RXREG,w1	; get data byte from UART RX
;	mov.b	WREG,RX_WR	; updare pointer (mod 256)
;	mov	w1,[--w0]	; put data byte in circular buffer
;no_rx_rq:
;	return
;go_tx:
;	btss	U1STA,#UTXBF
;	return			; TX register full
;	mov	w0,TX_CIRCULAR
;	mov.b	TX_RD,WREG
;	cp.b	TX_WR
;	bra	z,no_tx_rq	; nothing to transmit
;	mov	[w0++],w1	; get data byte from circular buffer
;	mov.b	WREG,TX_RD	; update pointer (mod 256)
;	mov	w1,U1TXREG	; put data byte in UART TX
;no_tx_rq:
;	return
;			;-------- UART END

;-------------------------------------------------------------------
;-------------------------------------------------------------------
;-----------               SUBROUTINES              ----------------
;-------------------------------------------------------------------
;-------------------------------------------------------------------

clr_buf:
	mov.b	CURCOL1,WREG
	btsc	CURFLAG,#0
	mov.b	CURCOL2,WREG

	and	#0x70,w0
	swap	w0
	ior	#0x20,w0

	mov	#BUFFER,w1
	repeat #1499
	mov	w0,[w1++]
	return

param_buf:
	clr	w0
	mov.b	CURCOL1,WREG
	btsc	CURFLAG,#0
	mov.b	CURCOL2,WREG
	swap	w0		; w0 = TKKK TFFF 0000 0000

	mov	#1500,w2
	mov	#BUFFER,w1
	mov	#0xff,w4	; w4 = 0000 0000 1111 1111
go_parbuf:
	and	w4,[w1],w3	; w3 = 0000 0000 XXXX XXXX
	ior	w3,w0,[w1++]	; w3 = TKKK TFFF XXXX XXXX
	dec	w2,w2
	bra	nz,go_parbuf
	return

bkgnd_buf:
	clr	w0
	mov.b	CURCOL1,WREG
	btsc	CURFLAG,#0
	mov.b	CURCOL2,WREG
	and	#0x70,w0
	swap	w0		; w0 = 0KKK 0000 0000 0000

	mov	#1500,w2
	mov	#BUFFER,w1
	mov	#0x8fff,w4	; w4 = 1000 1111 1111 1111
go_bkbuf:
	and	w4,[w1],w3	; w3 = X000 XXXX XXXX XXXX
	ior	w3,w0,[w1++]	; w3 = XKKK XXXX XXXX XXXX
	dec	w2,w2
	bra	nz,go_bkbuf
	return

adr_c:
	btsc	CURFLAG,#0
	bra	adr_c2
adr_c1:				; calculates address from cursor 1 position
	mov	#60,w0
	cp.b	CURSOR1
	bra	c,go_dummy
	mov	#25,w0
	cp.b	CURSOR1+1
	bra	c,go_dummy

	mov	#120,w0
	mul.b	CURSOR1+1
	sl.b	CURSOR1,WREG
	add	w2,w0,w2
	mov	#BUFFER,w0
	add	w2,w0,w2
	return

adr_c2:				; calculates address from cursor 2 position
	mov	#60,w0
	cp.b	CURSOR2
	bra	c,go_dummy
	mov	#25,w0
	cp.b	CURSOR2+1
	bra	c,go_dummy

	mov	#120,w0
	mul.b	CURSOR2+1
	sl.b	CURSOR2,WREG
	add	w2,w0,w2
	mov	#BUFFER,w0
	add	w2,w0,w2
	return
go_dummy:
	mov	#DUMMY,w2
	return
;--------------------------------
adv_cur:
	mov	#CURSOR1,w2
	btsc	CURFLAG,#0
	mov	#CURSOR2,w2
	mov	[w2],w1
	inc.b	w1,w1		; x pos increment
	mov.b	BOUND_R,WREG
	cpsgt.b	w1,w0
	bra	1f		; x pos in range
	mov.b	BOUND_L,WREG
	mov.b	w0,w1		; home x pos
	swap	w1		; \
	inc.b	w1,w1		; y pos increment
	mov.b	BOUND_D,WREG
	cpsgt.b	w1,w0
	bra	2f		; y pos in range
	mov.b	w0,w1		; y pos saturated
2:
	swap	w1		; /
1:
	mov	w1,[w2]
	return

back_cur:
	mov	#CURSOR1,w2
	btsc	CURFLAG,#0
	mov	#CURSOR2,w2
	mov	[w2],w1
	mov.b	BOUND_L,WREG
	cpseq.b	w1,w0
	cpsgt.b	w1,w0
	bra	1f		; x pos will be out of range after decrement
	dec.b	w1,w1
	mov	w1,[w2]
	return
1:
	mov.b	BOUND_R,WREG
	mov.b	w0,w1
	
	swap	w1
	mov.b	BOUND_U,WREG
	cpseq.b	w1,w0
	dec.b	w1,w1
	swap	w1
	mov	w1,[w2]
	return

;---------------------------------
setspeed:			; move curXspeed from table to periodX
	mov	#0xf,w0
	and.b	CUR1SPEED
	and.b	CUR2SPEED
	mov	#tbloffset(speedtable),w1
	clr	w0
	mov.b	CUR1SPEED,WREG
	add	w0,w1,w0
	tblrdl.b [w0],w0
	mov.b	WREG,PERIOD1
	clr	w0
	mov.b	CUR2SPEED,WREG
	add	w0,w1,w0
	tblrdl.b [w0],w0
	mov.b	WREG,PERIOD2
	return

;---------------------------------

printhex:
	mov	#BUFFER,w1
printw1:
	mov	#tbloffset(hextab),w3

	push	w0	; \
	swap	w0
	push	w0	; \\
	swap.b	w0
	and	#0xf,w0
	add	w0,w3,w0
	tblrdl.b [w0],[w1++]
	mov	#0x7,w0
	mov.b	w0,[w1++]

	pop	w0	; //
	and	#0xf,w0
	add	w0,w3,w0
	tblrdl.b [w0],[w1++]
	mov	#0x7,w0
	mov.b	w0,[w1++]
	pop	w0	; /

	push	w0	; \
	swap.b	w0
	and	#0xf,w0
	add	w0,w3,w0
	tblrdl.b [w0],[w1++]
	mov	#0x7,w0
	mov.b	w0,[w1++]

	pop	w0	; /
	and	#0xf,w0
	add	w0,w3,w0
	tblrdl.b [w0],[w1++]
	mov	#0x7,w0
	mov.b	w0,[w1++]

	return	
;-------------------------------------------------------------------

/*
Wait for key pressed (FLAG,#1 set) and continue convert_key routine
*/

get_key:
	btss	FLAG,#1
	bra	get_key		; loop unil key pressed

/*
Clear FLAG,#1 and get key code from KBDBUF 
If code >220, it is break code; update KBDFLAG bits and return code in W0
If code >186, it is numeric keypad spec code; translate it to ? * - + . ENTER
If code >176, it is numeric keypad 0-9 code; reset bit 7 and return ASCII in W0
IF CAPS LOCK active (KBDFLAG,#8 set), convert lowercase to upprecase
If SHIFT pressed, exchange lowercase and uppercase via lookup table SHIFT_CONV
*/

convert_key:
	bclr	FLAG,#1
	mov	KBDBUF,w0	; get key ASCII or spec code

	mov	#220,w1
	cp	w0,w1
	bra	c,brk_codes	; break codes - just reset flags

	mov	#176,w1
	cp	w0,w1
	bra	c,kp_num	; keypad numerics - just conv to numerics

	mov	#140,w1
	cpsne	w0,w1
	btg	KBDFLAG,#8	; CAPS LOCK toggle

	mov	#77,w1
	cpsne	w0,w1
	btg	KBDFLAG,#9	; NUM LOCK toggle

	mov	#146,w1
	cpsne	w0,w1
	btg	KBDFLAG,#10	; SCROLL LOCK toggle

	mov	#128,w1
	cp	w0,w1
	bra	c,spec_keys	; >128 = spec keys

	btss	KBDFLAG,#8
	bra	no_caps
				; CAPS LOCK active	
	mov	#'a',w1
	cp	w0,w1
	bra	nc,no_caps
	mov	#'z'+1,w1
	cp	w0,w1
	bra	c,no_caps
	sub	#32,w0		; lowercase >> uppercase
no_caps:
	btss	KBDFLAG,#0
	bra	no_shift
	mov	#32,w1
	cp	w0,w1
	bra	nc,no_shift	; <32
	btsc	w0,#7
	bra	no_shift	; >127

	mov	#tbloffset(shift_conv)-32,w1
	add	w1,w0,w1
	tblrdl.b [w1],w0	
no_shift:
	return

spec_keys:
	mov	#141,w1
	cpsne	w0,w1
	bset	KBDFLAG,#0	; SHIFT make
	mov	#142,w1
	cpsne	w0,w1
	bset	KBDFLAG,#1	; CTRL make
	mov	#144,w1
	cpsne	w0,w1
	bset	KBDFLAG,#2	; ALT make
	return

kp_num:
	mov	#186,w1
	cp	w0,w1
	bra	nc,just_num

	mov	#'/',w2
	sub	#186,w0
	bra	z,num_exit

	mov	#'*',w2
	dec	w0,w0
	bra	z,num_exit

	mov	#'-',w2
	dec	w0,w0
	bra	z,num_exit

	mov	#'+',w2
	dec	w0,w0
	bra	z,num_exit

	mov	#13,w2
	dec	w0,w0
	bra	z,num_exit

	mov	#'.',w2
	dec	w0,w0
	bra	z,num_exit

	clr	w0
just_num:
	bclr	w0,#7
	return
num_exit:
	mov	w2,w0
	return

brk_codes:
	sub	w0,w1,w1
	btsc	SR,#Z
	bclr	KBDFLAG,#0	; SHIFT break
	dec	w1,w1
	btsc	SR,#Z
	bclr	KBDFLAG,#1	; CTRL break
	dec	w1,w1
	btsc	SR,#Z
	bclr	KBDFLAG,#2	; ALT break
	dec	w1,w1
	btsc	SR,#Z
	bclr	KBDFLAG,#3	; ENTER break
	return

;--------------------------------------------------------------------
;--------------------------------------------------------------------  LINE & BOX
;--------------------------------------------------------------------

pbox:
	sub	#0x101,w3	; -1=x, y-1=y
	mov	#0x02,w0	; upper left corner -
	call	corner
	call	phor		; upper line

	push	w1	; \
	mov.b	6+1,WREG
	add.b	2+1		; w1hi+w3hi=w1hi
	mov	#0x05,w0	; lower left corner L
	call	corner
	call	phor		; lower line
	add.b	w1,w3,w1
	mov	#0x04,w0	; lower right corner -
	call	corner
	pop	w1	; /

	swap	w3
	call	pvert		; left line
	swap	w3
	add.b	w1,w3,w1	; w1lo+w3lo=w1lo
	swap	w3
	mov	#0x03,w0	; upper right corner 
	call	corner
	call	pvert		; right line

	return

;-------------------------------- BOX2
pbox2:
	sub	#0x101,w3	; -1=x, y-1=y
	mov	#0x12,w0	; upper left corner -
	call	corner
	call	phor2		; upper line

	push	w1	; \
	mov.b	6+1,WREG	; ...
	add.b	2+1		; w1hi+w3hi=w1hi
	mov	#0x15,w0	; lower left corner L
	call	corner
	call	phor2		; lower line
	add.b	w1,w3,w1
	mov	#0x14,w0	; lower right corner -
	call	corner
	pop	w1	; /

	swap	w3
	call	pvert2		; left line
	swap	w3
	add.b	w1,w3,w1	; w1lo+w3lo=w1lo
	swap	w3
	mov	#0x13,w0	; upper right corner 
	call	corner
	call	pvert2		; right line

	return

corner:
	swap	w4
	push	w0	; \
	mov	#120,w0
	mul.b	2+1		; 2+1 = w1 hi byte
	sl.b	2,WREG		; 8 = w1 lo byte
	add	w2,w0,w2
	mov	#BUFFER,w0
	add	w2,w0,w2	; w2 = corner addr in video mem
	pop	w0	; /
	ior	w0,w4,[w2]
	swap	w4
	return

;-------------------------------- HOR
phor:
	mov	#0x00,w5	; horizontal line
	mov	#tbloffset(fit1h),w6
	bra	skrhor

;-------------------------------- HOR2
phor2:
	mov	#0x10,w5	; double horizontal line
	mov	#tbloffset(fit2h),w6
skrhor:
	push	w1	; \
	swap	w4
	mov	#120,w0
	mul.b	2+1		; 2+1 = w1 hi byte
	sl.b	2,WREG		; 8 = w1 lo byte
	add	w2,w0,w2
	mov	#BUFFER,w0
	add	w2,w0,w2	; w2 = line start addr in video mem

	call	linefith	; first line char to write
	add	#32,w6		; next fit table

	clr	w0
	sub.b	w3,#2,w0
	bra	z,1f		; loop count = 0
	bra	nc,1f		; loop count < 0
	mov	w0,DOCOUNT
2:				; \000\
	call	linefith	; all line chars except 1st and last
	dec	DOCOUNT
	bra	nz,2b		; /
1:
	add	#32,w6		; next fit table
	call	linefith	; last line char to write
	swap	w4
	pop	w1	; /
	return

linefith:
	clr	w0
	mov.b	[w2],w0		; existing char in video mem
	cp.b	w0,#31
	btss	SR,#Z
	bra	c,nofith	; no fit if there was not box char

	add	w6,w0,w0
	clr	w1
	tblrdl.b [w0],w1	
	ior	w4,w1,[w2++]	; write modified line
	return
nofith:
	ior	w4,w5,[w2++]	; write unmodified line
	return

;-------------------------------- VERT
pvert:
	mov	#0x01,w5	; vertical line
	mov	#tbloffset(fit1v),w6
	bra	skrvert

;-------------------------------- VERT2
pvert2:
	mov	#0x11,w5	; double vertical line
	mov	#tbloffset(fit2v),w6
skrvert:
	push	w1	; \
	swap	w4
	mov	#120,w0
	mul.b	2+1		; 2+1 = w1 hi byte
	sl.b	2,WREG		; 8 = w1 lo byte
	add	w2,w0,w2
	mov	#BUFFER,w0
	add	w2,w0,w2	; w2 = line start addr in video mem

	call	linefith	; first line char to write
	add	#118,w2		; readjust horizontal to vertical step
	add	#32,w6		; next fit table

	clr	w0
	sub.b	w3,#2,w0
	bra	z,1f		; loop count = 0
	bra	nc,1f		; loop count < 0
	mov	w0,DOCOUNT
2:				; \000\
	call	linefith	; all line chars except 1st and last
	add	#118,w2		; readjust horizontal to vertical step

	dec	DOCOUNT
	bra	nz,2b		; /
1:
	add	#32,w6		; next fit table
	call	linefith	; last line char to write
	swap	w4
	pop	w1	; /
	return

;--------------------------------

keydata:
	push	w0	; \
	mov	#BUFFER+30,w1
	call	printw1
	mov	RAW_KEY+2,w0
	call	printhex
	mov	RAW_KEY,w0
	mov	#BUFFER+10,w1
	call	printw1
	mov	RAW_KEY+4,w0
	mov	#BUFFER+20,w1
	call	printw1
	pop	w0	; /
	return
;-------------------------------------------------------------------

rx_test:
	mov	#RX_CIRCULAR,w0	; preset high address byte for RX circular buffer
	mov.b	RX_RD,WREG	; get low address byte from the pointer
	cp.b	RX_WR		; compare pointers
	bra	z,no_rx		; nothing was received
	mov	[w0++],w1	; read byte from RX circular buffer
	mov.b	WREG,RX_RD	; update RX_RD pointer
	bset	SR,#C		; SET C (notify that word was received)
	return			; received word is in w1
no_rx:
	bclr	SR,#C		; CLR C (notify that nothing was received)
	return

tx_test:
	mov	#TX_CIRCULAR,w0	; preset high address byte for TX circular buffer
	inc2.b	TX_WR,WREG	; get low address byte +2mod256 from the pointer
	cp.b	TX_RD		; compare pointers
	bra	z,no_room	; no room in tx circular buffer
	mov.b	WREG,TX_WR	; update TX_WR pointer
	mov	w1,[--w0]	; put word in TX circular buffer
	bclr	SR,#C		; CLR C (notify that word was placed in circ buffer)
	return
no_room:
	bset	SR,#C		; SET C (notify that tx circular buffer was full)
	return

;-------------------------------------------------------------------

 .end
 