
.bss
.align (2)

AUX_BUFFER:	.space 700	; temp video ram storage during demo help
AUX_ASCII_BUF:	.space 736	; temp video ram storage during demo ascii set
HELPFLAG:	.space 2	; bit 0: set if help screen active in demo mode
				; bit 1: set if ASCII active

.text
	goto	key_f1		;  G O   D E M O   M O D E

loop:				; 10s bez int-a
	mov	#26000,w5
gowait:
	repeat #15000
	nop
	dec	w5,w5
	bra	nz,gowait
	return




farm:
	call	show_txt_par
	call	get_key
;	call	keydata	;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	btsc	KBDFLAG,#1		; bit 1 = CTRL
	bra	ctrl_key
	btsc	KBDFLAG,#2		; bit 2 = ALT
	bra	alt_key

	mov	#0x20,w1
	cp.b	w0,w1
	bra	nc,lth20	; lth20: 9 tab, 8 bksp, 13 enter
	mov	#0x80,w1
	cp.b	w0,w1
	bra	c,gth7f		; gth7f: all commands except lth20

	mov	w0,w1
	call	adr_c		; w2 = address in video mem

	mov.b	CURCOL1,WREG
	btsc	CURFLAG,#0
	mov.b	CURCOL2,WREG

	mov.b	WREG,WREG1H
	mov	w1,[w2]		; write char at active cursor location
	call	adv_cur
blink_sync:
	setm.b	BLINK_COUNT1
	setm.b	BLINK_COUNT2
	goto	farm


print_help:
	mov	#tbloffset(string1),w1
	mov	#tbloffset(string2),w2
	mov	#BUFFER,w3
	mov	#25,w5
2:
	add	#92,w3
	mov	#14,w4
3:
	tblrdl.b [w1++],w9	; get char
	tblrdl.b [w2++],w7	; get attrib

	dec	w5,w6
	bra	z,atr_ch	; last row: change attributes
	cp	w5,#11
	bra	nc,no_atr_ch	; rows 16-24: do not change attributes
atr_ch:
	mov	w7,w6
	mov	[w3],w8	
	swap	w8
	and	#0x70,w8	; WREG8L: existing bkgnd attrib in video mem
	and	#0x70,w6	; WREG6L: new bkgnd attrib
	btsc	SR,#Z		; skip if new bkgnd not black
	ior	w8,w7,w7	; WREG7L contains new attributes

	asr	w7,w8
	and	#0b00111000,w8
	and	w7,#7,w0
	ior	w0,w8,w0	; w0 = new bkgnd*8 + new foregnd
	mov	#tbloffset(help_atr_tab),w8
	add	w0,w8,w0
	tblrdl.b [w0],w0	; get new colour attrib from table

	and	#0x88,w7	; WREG7L still holds blinking attributes
	ior.b	w7,w0,w7	; new attrib

	mov.b	w9,[w3++]	; move char to video mem
	mov.b	w7,[w3++]	; put attrib
	bra	4f
no_atr_ch:
	mov.b	w9,[w3++]	; move char to video mem
	mov	w7,w0
	and.b	#0x70,w0
	bra	nz,5f		; new attr not black - hold it
	mov.b	[w3],w0
	and.b	#0x70,w0	; isolate screen bkgnd
	ior.b	w0,w7,w7
5:
	mov.b	w7,[w3++]	; move attrib to video mem
4:
	dec	w4,w4
	bra	nz,3b
	dec	w5,w5
	bra	nz,2b

	mov	#0x7000,w5	; cpl bkgnd
	mov	#BUFFER+(15*120)+93,w3	; repair next 6 bytes (ctrl-R)
	rcall	repair6
	rcall	repair6
	rcall	repair6
	rcall	repair6
	rcall	repair6
	rcall	repair6
	rcall	repair6
	rcall	repair6
	mov	#0x0700,w5	; cpl foregnd
	rcall	repair6

	mov	#BUFFER+(22*120)+106,w3	; repair next 7 bytes (alt-K)
	mov	#0x8fff,w0	; make next 7 bkgnds black unconditionaly
	mov	#7,w4
2:
	and	w0,[w3],[w3++]
	dec	w4,w4
	bra	nz,2b
1:

repair6:
	mov	#6,w4
	push	w3	; \
	mov.b	[w3],w0		; 1st char attrib
	and.b	#0x70,w0	; isolate bkgnd colour
	swap.b	w0
	mov.b	[w3--],w1	; 1st char attrib
	and.b	#7,w1		; isolate foregnd colour
	cp.b	w1,w0
	bra	nz,1f
2:				; 1st bkgnd = foregnd; cpl next w4 bkgnds/foregnds
	xor	w5,[w3],[w3++]
	dec	w4,w4
	bra	nz,2b
1:
	pop	w3	; /
	add	#120,w3
	return

help_atr_tab:
;        blk  red  grn  yel  blu  mag  cya  whi foregnd
 .byte	0x07,0x01,0x02,0x03,0x07,0x05,0x06,0x07 ; blk bkgnd
 .byte	0x10,0x17,0x12,0x13,0x14,0x10,0x16,0x17 ; red
 .byte	0x20,0x21,0x20,0x20,0x24,0x25,0x24,0x27 ; grn
 .byte	0x30,0x31,0x32,0x35,0x34,0x35,0x34,0x30 ; yel
 .byte	0x47,0x41,0x42,0x43,0x47,0x45,0x46,0x47 ; blu
 .byte	0x50,0x57,0x52,0x53,0x54,0x50,0x56,0x57 ; mag
 .byte	0x60,0x61,0x62,0x65,0x64,0x65,0x60,0x64 ; cya
 .byte	0x70,0x71,0x72,0x75,0x74,0x75,0x74,0x70 ; whi

show_txt_par:
	btss	HELPFLAG,#0
	return
	mov	#BUFFER+92,w1
	mov.b	CURCOL1,WREG
	mov	#6,w2
1:
	inc	w1,w1
	mov.b	w0,[w1++]
	dec	w2,w2
	bra	nz,1b

	mov	#BUFFER+106,w1
	mov.b	CURCOL2,WREG
	mov	#6,w2
2:
	inc	w1,w1
	mov.b	w0,[w1++]
	dec	w2,w2
	bra	nz,2b

	mov	#141,w0
	btsc	CURFLAG,#0
	bra	mark_cur2
	mov.b	WREG,BUFFER+92
	mov.b	WREG,BUFFER+94
	mov	#' ',w0
	mov.b	WREG,BUFFER+106
	mov.b	WREG,BUFFER+108
	mov.b	WREG,BUFFER+114
	mov.b	WREG,BUFFER+116
	mov	#143,w0
	mov.b	WREG,BUFFER+100
	mov.b	WREG,BUFFER+102
	return
mark_cur2:
	mov.b	WREG,BUFFER+106
	mov.b	WREG,BUFFER+108
	mov	#' ',w0
	mov.b	WREG,BUFFER+92
	mov.b	WREG,BUFFER+94
	mov.b	WREG,BUFFER+100
	mov.b	WREG,BUFFER+102
	mov	#143,w0
	mov.b	WREG,BUFFER+114
	mov.b	WREG,BUFFER+116
	return

;================================
ctrl_key:
	mov	#0x60,w1
	cpsgt.b	w0,w1
	add.b	#0x20,w0	; conv uppercase to lowercase
	mov.b	#'r',w1
	cpsne.b	w0,w1
	bra	ctrlr
	mov.b	#'g',w1
	cpsne.b	w0,w1
	bra	ctrlg
	mov.b	#'b',w1
	cpsne.b	w0,w1
	bra	ctrlb
	mov.b	#'c',w1
	cpsne.b	w0,w1
	bra	ctrlc
	mov.b	#'m',w1
	cpsne.b	w0,w1
	bra	ctrlm
	mov.b	#'y',w1
	cpsne.b	w0,w1
	bra	ctrly
	mov.b	#'w',w1
	cpsne.b	w0,w1
	bra	ctrlw
	mov.b	#'k',w1
	cpsne.b	w0,w1
	bra	ctrlk
	mov.b	#'x',w1
	cpsne.b	w0,w1
	bra	ctrlx
	goto	farm

ctrlr:
	mov	#0x01,w4
	bra	ctrl_
ctrlg:
	mov	#0x02,w4
	bra	ctrl_
ctrlb:
	mov	#0x04,w4
	bra	ctrl_
ctrlc:
	mov	#0x06,w4
	bra	ctrl_
ctrlm:
	mov	#0x05,w4
	bra	ctrl_
ctrly:
	mov	#0x03,w4
	bra	ctrl_
ctrlw:
	mov	#0x07,w4
	bra	ctrl_
ctrlk:
	mov	#0x00,w4
ctrl_:
	btsc	KBDFLAG,#8	; caps lock active
	bra	ink_params
	btsc	CURFLAG,#0
	bra	ctrl_cur2
				; cursor 1 active
	mov.b	CURCOL1,WREG
	and	#0xf8,w0
	ior.b	w0,w4,w0
	mov.b	WREG,CURCOL1
	goto	farm
ctrl_cur2:			; cursor 2 active
	mov.b	CURCOL2,WREG
	and	#0xf8,w0
	ior.b	w0,w4,w0
	mov.b	WREG,CURCOL2
	goto	farm
ink_params:
	and	#0x0f,w4
	call	adr_c
	mov.b	[++w2],w0
	and	#0xf0,w0
	ior.b	w0,w4,[w2]
	call	adv_cur
	goto	farm
ctrlx:
	btsc	CURFLAG,#0
	bra	cx_cur2
	mov.b	#0x08,w0
	xor.b	CURCOL1
	goto	farm
cx_cur2:
	mov.b	CURCOL2,WREG
	mov.b	#0x08,w0
	xor.b	CURCOL2
	goto	farm

;================================
alt_key:
	mov	#0x60,w1
	cpsgt.b	w0,w1
	add.b	#0x20,w0	; conv uppercase to lowercase
	mov.b	#'r',w1
	cpsne.b	w0,w1
	bra	altr
	mov.b	#'g',w1
	cpsne.b	w0,w1
	bra	altg
	mov.b	#'b',w1
	cpsne.b	w0,w1
	bra	altb
	mov.b	#'c',w1
	cpsne.b	w0,w1
	bra	altc
	mov.b	#'m',w1
	cpsne.b	w0,w1
	bra	altm
	mov.b	#'y',w1
	cpsne.b	w0,w1
	bra	alty
	mov.b	#'w',w1
	cpsne.b	w0,w1
	bra	altw
	mov.b	#'k',w1
	cpsne.b	w0,w1
	bra	altk
	mov.b	#'x',w1
	cpsne.b	w0,w1
	bra	altx
	goto	farm

altr:
	mov	#0x10,w4
	bra	alt_
altg:
	mov	#0x20,w4
	bra	alt_
altb:
	mov	#0x40,w4
	bra	alt_
altc:
	mov	#0x60,w4
	bra	alt_
altm:
	mov	#0x50,w4
	bra	alt_
alty:
	mov	#0x30,w4
	bra	alt_
altw:
	mov	#0x70,w4
	bra	alt_
altk:
	mov	#0x00,w4
alt_:
	btsc	KBDFLAG,#8	; caps lock active
	bra	pap_params
	btsc	CURFLAG,#0
	bra	alt_cur2
				; cursor 1 active
	mov.b	CURCOL1,WREG
	and	#0x8f,w0
	ior.b	w0,w4,w0
	mov.b	WREG,CURCOL1
	goto	farm
alt_cur2:			; cursor 2 active
	mov.b	CURCOL2,WREG
	and	#0x8f,w0
	ior.b	w0,w4,w0
	mov.b	WREG,CURCOL2
	goto	farm
pap_params:
	and	#0xf0,w4
	call	adr_c
	mov.b	[++w2],w0
	and	#0x0f,w0
	ior.b	w0,w4,[w2]
	call	adv_cur
	goto	farm
altx:
	btsc	CURFLAG,#0
	bra	ax_cur2
	mov.b	#0x80,w0
	xor.b	CURCOL1
	goto	farm
ax_cur2:
	mov.b	CURCOL2,WREG
	mov.b	#0x80,w0
	xor.b	CURCOL2
	goto	farm

;--------------------------------
lth20:
	cp.b	w0,#8		; 8 = bksp
	bra	z,bksp
	cp.b	w0,#9		; 9 = tab
	bra	z,tab
	cp.b	w0,#13		; 13 = enter
	bra	z,enter
	cp.b	w0,#13		; 27 = esc
	bra	z,escape
	goto	farm

bksp:				; <-- bksp ept
	call	back_cur
	call	adr_c
	mov.b	#' ',w1
	mov.b	w1,[w2]
	bra	blink_sync

tab:				; <-- tab ept
	btg	CURFLAG,#0
	bra	blink_sync

enter:				; <-- enter ept
	mov	#CURSOR1,w3
	btsc	CURFLAG,#0
	mov	#CURSOR2,w3
	mov.b	BOUND_R,WREG
	mov.b	w0,[w3]
	call	adv_cur
	bra	blink_sync

escape:				; <-- esc ept
	clr	KBDFLAG
	goto	farm

;--------------------------------
gth7f:
	and	#0x7f,w0
	cp	w0,#(jp_end-jp_tab)/2
	btsc	SR,#C
	goto	farm		; command overflowed jump table
	sl	w0,w0
	mov	#tbloffset(jp_tab),w1
	add	w0,w1,w0
	goto	w0		; execute command

jp_tab:
	bra	key_f1		; 128: f1
	bra	f2		; 129: f2
	bra	f3		; 130: f3
	bra	f4		; 131: f4
	bra	f5		; 132: f5
	bra	f6		; 133: f6
	bra	f7		; 134: f7
	bra	f8		; 135: f8
	bra	f9		; 136: f9
	bra	f10		; 137: f10
	bra	f11		; 138: f11
	bra	f12		; 139: f12

	bra	caps		; 140: caps lock
	bra	farm		; 141: shift
	bra	farm		; 142: ctrl
	bra	farm		; 143: gui
	bra	farm		; 144: alt
	bra	prt_scr		; 145: print screen
	bra	farm		; 146: scroll lock
	bra	farm		; 147: pause
	bra	farm		; 148: ins
	bra	home		; 149: home

	bra	farm		; 150: pg up
	bra	del		; 151: del
	bra	key_end		; 152: end
	bra	farm		; 153: pg dn
	bra	arrow_up	; 154: up arrow
	bra	arrow_left	; 155: left arrow
	bra	arrow_down	; 156: down arrow
	bra	arrow_right	; 157: right arrow
	bra	farm		; 158: num lock
jp_end:

;-------------------
key_f1:				; <-- 128: f1 ept (HELP-EXIT)
	mov	#BUFFER,w1
	mov	#AUX_BUFFER,w2
	mov	#25,w4
	btsc	HELPFLAG,#0
	bra	end_demo
make_demo:
	add	#120-28,w1
	repeat #13
	mov	[w1++],[w2++]
	dec	w4,w4
	bra	nz,make_demo

	call	print_help
	bset	HELPFLAG,#0
	bra	caps
end_demo:
	add	#120-28,w1
	repeat #13
	mov	[w2++],[w1++]
	dec	w4,w4
	bra	nz,end_demo

	bclr	HELPFLAG,#0
	bra	farm
;-------------------
f2:				; <-- 129: f2 ept (MODE)
	btg	FLAG,#0
	bra	farm
;-------------------
get_box_dim:
	mov	#CURSOR1,w0
	mov	#CURSOR2,w2
	mov.b	[w0++],w5	; cursor 1 X
	mov.b	[w0--],w6	; cursor 1 Y
	mov.b	[w2++],w7	; cursor 2 X
	mov.b	[w2--],w8	; cursor 2 Y

	cp.b	w5,w7
	bra	nc,w7bigger
	push	w5	; \	; !bug in dsPIC does not allow EXCH instruction!
	mov	w7,w5
	pop	w7	; /
w7bigger:
	sub.b	w7,w5,w7	; w5 start X, w7 dim X

	cp.b	w6,w8
	bra	nc,w8bigger
	push	w6	; \	; !bug in dsPIC does not allow EXCH instruction!
	mov	w8,w6
	pop	w8	; /
w8bigger:
	sub.b	w8,w6,w8	; w6 start Y, w8 dim Y

	mov.b	w6,w1
	swap	w1
	mov.b	w5,w1		; w1 = start X(lo),Y(hi)
	clr	w4
	mov.b	CURCOL1,WREG
	btsc	CURFLAG,#0
	mov.b	CURCOL2,WREG
	mov.b	w0,w4		; w4 = active cursor color	
	clr	w3
	return

f3:				; <-- 130: f3 ept (SINGLE BOX)
	call	get_box_dim
	cp0.b	w7
	bra	z,line_vert1
	cp0.b	w8
	bra	z,line_hor1
				; box here
	inc.b	w8,w3
	swap	w3
	inc.b	w7,w3		; w3 = box dim X(lo),Y(hi)

	call	pbox		; B O X
	bra	farm

line_vert1:			; vert line here
	cp0.b	w8
	bra	z,farm		; if dim 0,0
	inc.b	w8,w3
	call	pvert		; L I N E
	bra	farm

line_hor1:			; hor line here
	inc.b	w7,w3
	call	phor		; L I N E
	bra	farm

;-------------------
f4:				; <-- 131: f4 ept (DOUBLE BOX)
	call	get_box_dim
	cp0.b	w7
	bra	z,line_vert2
	cp0.b	w8
	bra	z,line_hor2
				; box here
	inc.b	w8,w3
	swap	w3
	inc.b	w7,w3		; w3 = box dim X(lo),Y(hi)

	call	pbox2		; B O X
	bra	farm

line_vert2:			; vert line here
	cp0.b	w8
	bra	z,farm		; if dim 0,0
	inc.b	w8,w3
	call	pvert2		; L I N E
	bra	farm

line_hor2:			; hor line here
	inc.b	w7,w3
	call	phor2		; L I N E
	bra	farm
;-------------------
f5:				; <-- 132: f5 ept (SCREEN COLOUR)
	mov.b	CURCOL1,WREG
	btsc	CURFLAG,#0
	mov.b	CURCOL2,WREG
	cp.b	SCREEN_ARG+1
	bra	z,reset_scr_p
	mov.b	WREG,SCREEN_ARG+1
	bra	farm
reset_scr_p:
	clr.b	SCREEN_ARG+1
	bra	farm
;-------------------
f6:				; <-- 133: f6 ept (SCREEN HEIGHT/WIDTH)
	inc.b	SCREEN_ARG
	bclr.b	SCREEN_ARG,#2
	bra	farm
;-------------------
f7:				; <-- 134: f7 ept (ROW COLOUR)
	clr	w0
	mov.b	CURSOR1+1,WREG	; y koord
	btsc	CURFLAG,#0
	mov.b	CURSOR2+1,WREG	; y koord
	sl	w0,w0
	mov	#LINE_ARG,w1
	add	w0,w1,w1
	inc	w1,w1		; w1 points to the row param to modify
	mov.b	CURCOL1,WREG
	btsc	CURFLAG,#0
	mov.b	CURCOL2,WREG

	cp.b	w0,[w1]
	bra	z,reset_row_p
	mov.b	w0,[w1]
	bra	farm
reset_row_p:
	clr.b	[w1]
	bra	farm
;-------------------
f8:				; <-- 135: f8 ept (ROW HEIGHT/WIDTH)
	clr	w0
	mov.b	CURSOR1+1,WREG	; y koord
	btsc	CURFLAG,#0
	mov.b	CURSOR2+1,WREG	; y koord
	sl	w0,w0
	mov	#LINE_ARG,w1
	add	w0,w1,w1	; w1 points to the row param to modify
	inc.b	[w1],[w1]
	bclr	[w1],#2
	bra	farm
;-------------------
f9:				; <-- 136: f9 ept (BACKGROUND)
	btss	KBDFLAG,#0
	call	bkgnd_buf
	mov.b	CURCOL1,WREG
	btsc	CURFLAG,#0
	mov.b	CURCOL2,WREG
	swap.b	w0
	and.b	#7,w0
	mov.b	WREG,MARGIN
help_farm:
	btsc	HELPFLAG,#0
	call	print_help
	bra	farm
;-------------------
f10:				; <-- 137: f10 ept (CURSOR HIDE)
	btg	CURFLAG,#1
	bra	farm
;-------------------
f11:				; <-- 138: f11 ept (CURSOR SLOW)
	mov	#CUR1SPEED,w2
	btsc	CURFLAG,#0
	mov	#CUR2SPEED,w2

	dec.b	[w2],w0
	btss	w0,#7
	mov.b	w0,[w2]
	call	setspeed
	bra	farm
;-------------------
f12:				; <-- 139: f12 ept (CURSOR FAST)
	mov	#CUR1SPEED,w2
	btsc	CURFLAG,#0
	mov	#CUR2SPEED,w2

	inc.b	[w2],w0
	btss	w0,#4
	mov.b	w0,[w2]
	call	setspeed
	bra	farm
;-------------------
home:				; <-- 149: home ept
	mov	#CURSOR1,w2
	btsc	CURFLAG,#0
	mov	#CURSOR2,w2
	mov.b	BOUND_L,WREG
	mov.b	w0,[w2]
	bra	blink_sync
;-------------------
del:				; <-- 151: del ept
	call	adr_c
	mov	#' ',w0
	mov.b	w0,[w2]
	call	adv_cur
	bra	blink_sync
;-------------------
key_end:			; <-- 152: end ept
	mov	#CURSOR1,w2
	btsc	CURFLAG,#0
	mov	#CURSOR2,w2
	mov.b	BOUND_R,WREG
	mov.b	w0,[w2]
	bra	blink_sync
;-------------------
arrow_up:			; <-- 154: up arrow ept
	mov.b	BOUND_U,WREG
	mov	#CURSOR1,w2
	btsc	CURFLAG,#0
	mov	#CURSOR2,w2
	mov.b	[++w2],w1
	cp.b	w0,w1
	btss	SR,#C		; skip if it's already in upper position
	dec.b	[w2],[w2]
	bra	blink_sync

;-------------------
arrow_left:			; <-- 155: left arrow ept
	call	back_cur
	bra	blink_sync
;-------------------
arrow_down:			; <-- 156: down arrow ept
	mov.b	BOUND_D,WREG
	mov	#CURSOR1,w2
	btsc	CURFLAG,#0
	mov	#CURSOR2,w2
	mov.b	[++w2],w1
	cp.b	w1,w0
	btss	SR,#C		; skip if it's already in lower position
	inc.b	[w2],[w2]
	bra	blink_sync

;-------------------
arrow_right:			; <-- 157: right arrow ept
	call	adv_cur
	bra	blink_sync

;-------------------
caps:
	btss	HELPFLAG,#0
	bra	farm

	mov	#BUFFER+(24*120)+92,w3
	mov	#14,w4

	btss	KBDFLAG,#8
	bra	capsoff
	mov	#0x0800,w5
	mov	#0xffff,w6
	bra	gocaps
capsoff:
	clr	w5
	mov	#0xf7ff,w6
gocaps:
	mov	[w3],w0
	and	w0,w6,w0
	ior	w0,w5,w0
	mov	w0,[w3++]
	dec	w4,w4
	bra	nz,gocaps
	goto	farm

;-------------------
prt_scr:
	clr	w0
	mov.b	CURCOL1,WREG
	btsc	CURFLAG,#0
	mov.b	CURCOL2,WREG
	and	#0x77,w0	; no blinking in ASCII table
	mov	w0,w1		; w1 = active cursor colour
	swap	w1
	mov.b	CURCOL2,WREG
	btsc	CURFLAG,#0
	mov.b	CURCOL1,WREG
	and	#0x77,w0	; no blinking in ASCII table
	mov	w0,w2		; w2 = non-active cursor colour
	swap	w2

	mov	#8,w6		; row count
	mov	#BUFFER+(120*17),w4
	mov	#AUX_ASCII_BUF,w5

	btss	HELPFLAG,#1
	bra	setascii
rasc8:				; remove ascii screen
	bclr	HELPFLAG,#1
	mov	#46,w7
rasc46:
	mov	[w5++],[w4++]		; move from aux mem to video mem
	dec	w7,w7
	bra	nz,rasc46

	add	#28,w4	
	dec	w6,w6
	bra	nz,rasc8
	goto	farm

setascii:
	bset	HELPFLAG,#1
	mov	#tbloffset(string3),w3
	clr	w8			; ASCII character 0...255
ascx8b:
	mov	#2,w10
ascx2b:
	mov	w2,w0			; colour
	mov	#3,w7
ascx3:
	mov	[w4],[w5++]		; move from video mem to aux mem
	tblrdl.b [w3++],w0		; get from decimal table
	mov	w0,[w4++]		; put in video mem
	dec	w7,w7
	bra	nz,ascx3

	mov	[w4],[w5++]		; move from video mem to aux mem
	mov.b	#':',w0
	mov	w0,[w4++]		; put in video mem

	mov	#2,w9
ascx2a:
	mov	[w4],[w5++]		; move from video mem to aux mem
	mov.b	#' ',w0
	mov	w0,[w4++]		; put in video mem

	mov	w1,w0			; colour
	mov	#8,w7
ascx8a:
	mov	[w4],[w5++]		; move from video mem to aux mem
	mov.b	w8,w0
	inc.b	w8,w8
	mov	w0,[w4++]		; put in video mem
	dec	w7,w7
	bra	nz,ascx8a

	dec	w9,w9
	bra	nz,ascx2a

	mov	[w4],[w5++]		; move from video mem to aux mem
	mov.b	#' ',w0
	mov	w0,[w4++]		; put in video mem

	dec	w10,w10
	bra	nz,ascx2b

	add	#28,w4

	dec	w6,w6
	bra	nz,ascx8b

	goto	farm



;--------------------------------------------------------------------
string1:
 .ascii "  C1     C2   "
 .ascii "TAB: CURSOR SW"
 .ascii "PRT SCR: ASCII"
 .ascii "F1: HELP/EXIT "
 .ascii "F2: MODE      "
 .ascii "F3: SINGLE BOX"
 .ascii "F4: DOUBLE BOX"
 .ascii "F5: SCREEN COL"
 .ascii "F6: SCREEN H/W"
 .ascii "F7: ROW COLOUR"
 .ascii "F8: ROW H/W   "
 .ascii "F9: BKGND (sh)"
 .ascii "F10: CURS HIDE"
 .ascii "F11: CURS SLOW"
 .ascii "F12: CURS FAST"
 .ascii "ctrl-R  alt-R "
 .ascii "ctrl-G  alt-G "
 .ascii "ctrl-B  alt-B "
 .ascii "ctrl-C  alt-C "
 .ascii "ctrl-M  alt-M "
 .ascii "ctrl-Y  alt-Y "
 .ascii "ctrl-W  alt-W "
 .ascii "ctrl-K  alt-K "
 .ascii "ctrl-X  alt-X "
 .ascii "caps on:ATTRIB"
			; red      1
			; green    2
			; blue     4
			; cyan     6
			; magenta  5
			; yellow   3
			; white    7
			; black    0
string2:
 .byte 0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07
 .byte 0x02,0x02,0x02,0x02,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05,0x05
 .byte 0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x07,0x07,0x07,0x07,0x07,0x07
 .byte 0x03,0x03,0x03,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06
 .byte 0x03,0x03,0x03,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06
 .byte 0x03,0x03,0x03,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06
 .byte 0x03,0x03,0x03,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06
 .byte 0x03,0x03,0x03,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07
 .byte 0x03,0x03,0x03,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07
 .byte 0x03,0x03,0x03,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07
 .byte 0x03,0x03,0x03,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07
 .byte 0x03,0x03,0x03,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06
 .byte 0x03,0x03,0x03,0x03,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06
 .byte 0x03,0x03,0x03,0x03,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06
 .byte 0x03,0x03,0x03,0x03,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06
 .byte 0x01,0x01,0x01,0x01,0x01,0x01,0x07,0x17,0x17,0x17,0x17,0x17,0x17,0x17
 .byte 0x02,0x02,0x02,0x02,0x02,0x02,0x07,0x20,0x20,0x20,0x20,0x20,0x20,0x20
 .byte 0x04,0x04,0x04,0x04,0x04,0x04,0x07,0x47,0x47,0x47,0x47,0x47,0x47,0x47
 .byte 0x06,0x06,0x06,0x06,0x06,0x06,0x07,0x60,0x60,0x60,0x60,0x60,0x60,0x60
 .byte 0x05,0x05,0x05,0x05,0x05,0x05,0x07,0x57,0x57,0x57,0x57,0x57,0x57,0x57
 .byte 0x03,0x03,0x03,0x03,0x03,0x03,0x07,0x30,0x30,0x30,0x30,0x30,0x30,0x30
 .byte 0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x70,0x70,0x70,0x70,0x70,0x70,0x70
 .byte 0x00,0x00,0x00,0x00,0x00,0x00,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07
 .byte 0x0f,0x0f,0x0f,0x0f,0x0f,0x0f,0x07,0xf1,0xf1,0xf1,0xf1,0xf1,0xf1,0xf1
 .byte 0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x06,0x02,0x02,0x02,0x02,0x02,0x02

string3:
 .ascii "  0 16 32 48 64 80 96112128144160156192208224240"
 
 
 