
.macro	hor	hx1,hy1,len1,col1
	mov	#\hy1*256+\hx1,w1	; line start y,x
	mov	#\len1,w3		; line length
	mov	#\col1,w4		; line color
	call	phor
.endm

.macro	hor2	hx2,hy2,len2,col2
	mov	#\hy2*256+\hx2,w1	; line start y,x
	mov	#\len2,w3		; line length
	mov	#\col2,w4		; line color
	call	phor2
.endm

.macro	vert	hx5,hy5,len5,col5
	mov	#\hy5*256+\hx5,w1	; line start y,x
	mov	#\len5,w3		; line length
	mov	#\col5,w4		; line color
	call	pvert
.endm

.macro	vert2	hx6,hy6,len6,col6
	mov	#\hy6*256+\hx6,w1	; line start y,x
	mov	#\len6,w3		; line length
	mov	#\col6,w4		; line color
	call	pvert2
.endm

.macro	box	hx3,hy3,dx3,dy3,col3
	mov	#\hy3*256+\hx3,w1	; box start y,x
	mov	#\dy3*256+\dx3,w3	; box dim y,x
	mov	#\col3,w4		; box color
	call	pbox
.endm

.macro	box2	hx4,hy4,dx4,dy4,col4
	mov	#\hy4*256+\hx4,w1	; box start y,x
	mov	#\dy4*256+\dx4,w3	; box dim y,x
	mov	#\col4,w4		; box color
	call	pbox2
.endm

.macro	l1l3
	rcall	line1
	rcall	term
	clr.b	[w1]
	rcall	line3
	rcall	term
	clr.b	[w1]
.endm

.macro	l1l2
	rcall	line1
	rcall	term
	clr.b	[w1]
	rcall	line2
	rcall	term
	clr.b	[w1]
.endm

.macro	l1l3p1
	rcall	line1
	rcall	term
	clr.b	[w1]
	rcall	line4
	rcall	term
	clr.b	[w1]
.endm

.macro	l1l3p2
	rcall	line1
	rcall	term
	clr.b	[w1]
	rcall	line5
.endm

.macro st_current_next
				; use w0 w1 w2 w5
	mov	#LINE_ARG,w0
	add	LINE_NUMBER,WREG
	add	LINE_NUMBER,WREG
	mov	SCREEN_ARG,w1	; screen ARG = w1
	mov	[w0],w2		; current line ARG = w2

	inc2	w0,w5	; w5 points to next line ARG (ignoring height & overflow)
	btss	w1,#1	; height: screen ARG
	btsc	w2,#1	; height: line ARG
	inc2	w5,w5	; w5 points to next line ARG (respecting...
			; ...height, but possible overflow)
	mov	#LINE_ARG+50,w0	; end of line_ARG list
	cpslt	w5,w0
	mov	#LINE_ARG,w5	; w5 points to next line ARG (respecting height)
	ior.b	w1,w2,w0	; tu su B, H, W
	mov.b	WREG,CURRENT_LINE
	ior.b	w1,[w5],w0	; next line ARG = w5
	mov.b	WREG,NEXT_LINE	; write B, H, W

	swap	w1		; lo byte: screen colour
	mov.b	[++w5],w0	; lo byte: next line colour

	cp0.b	w1
	btss	SR,#Z
	mov.b	w1,w0
	mov.b	WREG,NEXT_LINE+1 ; write T BBB T FFF
.endm

;--------------------------------
.macro	extrajob		; tests KBDCLOCK i rotates KBDDATA in KBDSTREAM
				; 25T max + return

	btsc	kbd_port,#kbd_clk	; kbd_clk
	bra	kbd_clk_hi\@
	btst	FLAG,#12
	bclr	FLAG,#12	; FLAG,#12 only follows kbd_clk
	bra	z,not_falling_edge\@
				; clock falling edge
	clr	KBDPAT
	dec.b	KBDCOUNT+1,WREG
	inc.b	KBDCOUNT+1
	cp.b	w0,#8
	bra	nc,databits\@
	cp.b	w0,#9
	bra	nz,exit_uart\@	; if the counter was 0-9-10, it only returns
				; end of one byte (9. bit just received)
	clr.b	KBDCOUNT+1
	inc.b	KBDCOUNT
	bra	exit_uart\@
databits\@:
	mov	#kbd_port,w0
	btst.c	[w0],#kbd_data	; KBD DATA
	rrc	KBDSTREAM+2
	rrc	KBDSTREAM
	bra	exit_uart\@

kbd_clk_hi\@:
	bset	FLAG,#12	; FLAG,#12 only follows kbd_clk
not_falling_edge\@:
	btsc	KBDPAT,#15
	bra	uart_service\@	; because KBDPAT is in default state 0xff
	inc	KBDPAT
	btss	KBDPAT,#7	; 128 cycles by 26,4us = 3.4 ms
	bra	uart_service\@	; because KBDPAT still did not measure 1,69ms
	mov	KBDSTREAM,w0
	mov	w0,KBDSTREAM2
	clr	KBDSTREAM
	mov	KBDSTREAM+2,w0
	mov	w0,KBDSTREAM2+2
	clr	KBDSTREAM+2
	mov.b	KBDCOUNT,WREG
	mov.b	WREG,KBDCOUNT2
	clr	KBDCOUNT
	setm	KBDPAT
	bra	exit_uart\@

uart_service\@:		;-------- UART START (timing might be critical)

;	repeat #10		;
;	nop			;
;	bra	exit_uart\@	; Worst-case test for uart, should be commented out

				; UART service, 13T max
	btss	U1STA,#URXDA
	bra	go_tx\@		; RX register empty, see if TX needs service

	mov	#RX_CIRCULAR,w0	; preset high address byte for RX circular buffer
	inc2.b	RX_WR,WREG	; get low address WR byte +2 from the pointer
	cp.b	RX_RD		; compare  RX_RD.b  -  RX_WR+2.b
	bra	z,exit_uart\@	; no room in FIFO256 (data is received, but lost)

	mov	U1RXREG,w1	; get data word from UART RX
	mov.b	WREG,RX_WR	; updare pointer (mod 256)
	mov	w1,[--w0]	; put data word in circular buffer
	bra	exit_uart\@
go_tx\@:
	btss	U1STA,#UTXBF
	bra	exit_uart\@	; TX register is full

	mov	#TX_CIRCULAR,w0	; preset high address byte for TX circular buffer
	mov.b	TX_RD,WREG	; get low address byte from the pointer
	cp.b	TX_WR
	bra	z,exit_uart\@	; nothing to transmit

	mov	[w0++],w1	; get data word from circular buffer
	mov.b	WREG,TX_RD	; update pointer (mod 256)
	mov	w1,U1TXREG	; put data word in UART TX
exit_uart\@:
.endm
